/*
;--------------------------------------------------------------------------------------------
; This is CGDI test sample.
;
#SingleInstance Force

Gui, Margin, 50, 50
loop % btnCount := 5
	Gui, Add, Progress, w100 h20 hWndhWnd%A_index%	; Progress controls make ideal canvases
Gui, Show, x0 y0

MyButton := {}
loop % btnCount
	MyButton[A_Index] := new CCustomButton(hwnd%A_index%)
OnMessage(0xF, "WM_PAINT")
OnMessage(0x200, "WM_MOUSEMOVE")
OnMessage(0x201, "WM_LBUTTONDOWN")
OnMessage(0x202, "WM_LBUTTONUP")
return

GuiClose:
ExitApp

WM_PAINT()
{
	global MyButton
	for, key, btn in MyButton
		btn.WM_PAINT()
}

WM_MOUSEMOVE(wParam, lParam, Msg, hWnd)
{
	global MyButton
	for, key, btn in MyButton
		btn.WM_MOUSEMOVE(wParam, lParam, Msg, hWnd)
}

WM_LBUTTONDOWN(wParam, lParam, Msg, hWnd)
{
	global MyButton
	for, key, btn in MyButton
		btn.WM_LBUTTONDOWN(wParam, lParam, Msg, hWnd)
}

WM_LBUTTONUP(wParam, lParam, Msg, hWnd)
{
	global MyButton
	for, key, btn in MyButton
		if btn.WM_LBUTTONUP(wParam, lParam, Msg, hWnd)
			clicked := key
	if clicked
		ToolTip, % clicked "  ư Ŭ"
	else
		ToolTip
}
;--------------------------------------------------------------------------------------------



;--------------------------------------------------------------------------------------------
; This is Custom Button
;--------------------------------------------------------------------------------------------
class CCustomButton
{
	__New(hWnd)
	{
		this.GDI := new CGDI(hWnd)
		this.hWnd := hWnd
		this.Default()
	}
	
	Default()
	{
		this.Draw("Hover", 0xFFFFFF, 0x000000)
	}
	
	Hovering()
	{
		this.Draw("Click", 0xC0C0C0, 0x000000)
	}
	
	Held()
	{
		this.Draw("Release", 0x000000, 0x0000FF)
	}
	
	Draw(Text, Color, TextColor)
	{
		critical
		this.GDI.FillRectangle(0, 0, this.GDI.CliWidth, this.GDI.CliHeight, Color, TextColor)
		this.GDI.DrawText(0, 0, this.GDI.CliWidth, this.GDI.CliHeight, Text, TextColor, "Courier New", 20, "CC")
		this.GDI.BitBlt()
	}
	
	BitBlt()
	{
		this.GDI.BitBlt()
	}

	;Needs Window Message Callback
	;OnMessage(0xF, "WM_PAINT")
	;OnMessage(0x200, "WM_MOUSEMOVE")
	;OnMessage(0x201, "WM_LBUTTONDOWN")
	;OnMessage(0x202, "WM_LBUTTONUP")

	WM_PAINT()
	{
		Sleep, -1 ; Let the scrollbar redraw before painting over it
		this.BitBlt()
	}

	WM_MOUSEMOVE(wParam, lParam, Msg, hWnd)
	{
		if (hWnd != this.LasthWnd)
		{
			if (hWnd == this.hWnd)
				this.Hovering()
			else if (this.lasthWnd == this.hWnd)
				this.Default()
			this.lasthWnd := hwnd
		}
	}
	
	WM_LBUTTONDOWN(wParam, lParam, Msg, hWnd)
	{
		if (hWnd == this.hWnd)
		{
			this.Held()
			this.clickdown := 1
		}
	}
	
	WM_LBUTTONUP(wParam, lParam, Msg, hWnd)
	{
		if (hWnd == this.hWnd)
		{
			this.Hovering()
			if this.clickdown
				return 1 , this.clickdown := 0
		}
		this.clickdown := 0
	}
}

*/

;============================================================================================
;  CGDI class
;
;  http://ahkscript.org/boards/viewtopic.php?f=6&t=5820
;============================================================================================
class CGDI
{
	__New(hWnd, CliWidth=0, CliHeight=0)
	{
		if !(CliWidth && CliHeight)
		{
			VarSetCapacity(Rect, 16, 0)
			DllCall("GetClientRect", "Ptr", hWnd, "Ptr", &Rect)
			CliWidth := NumGet(Rect, 8, "Int")
			CliHeight := NumGet(Rect, 12, "Int")
		}
		this.CliWidth := CliWidth
		this.CliHeight := CliHeight
		this.hWnd := hWnd
		this.hDC := DllCall("GetDC", "UPtr", hWnd, "UPtr")
		this.hMemDC := DllCall("CreateCompatibleDC", "UPtr", this.hDC, "UPtr")
		this.hBitmap := DllCall("CreateCompatibleBitmap", "UPtr", this.hDC, "Int", CliWidth, "Int", CliHeight, "UPtr")
		this.hOriginalBitmap := DllCall("SelectObject", "UPtr", this.hMemDC, "UPtr", this.hBitmap)
	}
	
	__Delete()
	{
		DllCall("SelectObject", "UPtr", this.hMemDC, "UPtr", this.hOriginalBitmap)
		DllCall("DeleteObject", "UPtr", this.hBitmap)
		DllCall("DeleteObject", "UPtr", this.hMemDC)
		DllCall("ReleaseDC", "UPtr", this.hWnd, "UPtr", this.hDC)
	}
	
	BitBlt(x=0, y=0, w=0, h=0)
	{
		w := w ? w : this.CliWidth
		h := h ? h : this.CliHeight
		
		DllCall("BitBlt", "UPtr", this.hDC, "Int", x, "Int", y
		, "Int", w, "Int", h, "UPtr", this.hMemDC, "Int", 0, "Int", 0, "UInt", 0xCC0020) ;SRCCOPY
	}
	
	DrawLine(x, y, x2, y2, Color)
	{
		Pen := new this.Pen(Color)
		DllCall("MoveToEx", "UPtr", this.hMemDC, "Int", this.TranslateX(x), "Int", this.TranslateY(y), "UPtr", 0)
		hOriginalPen := DllCall("SelectObject", "UPtr", this.hMemDC, "UPtr", Pen.Handle, "UPtr")
		DllCall("LineTo", "UPtr", this.hMemDC, "Int", this.TranslateX(x2), "Int", this.TranslateY(y2))
		DllCall("SelectObject", "UPtr", this.hMemDC, "UPtr", hOriginalPen, "UPtr")
	}
	
	SetPixel(x, y, Color, Fast=False)
	{
		x := this.TranslateX(x)
		y := this.TranslateY(y, this.Invert) ; Move up 1 px if inverted (drawing "up" instead of down)
		DllCall("SetPixel" (Fast?"V":""), "UPtr", this.hMemDC, "Int", x, "Int", y, "UInt", Color)
	}
	
	DrawText(x, y, w, h, Text, Color, Typeface, TextHeight, Align="CC", Weight=500, Style=0)
	{
		AlignH := {"L": 0x00, "C": 0x01, "R": 0x02}
		AlignV := {"C": 0x24, "B": 0x28, "T": 0x00}
		Align := StrSplit(Align)
		
		Font := new this.Font(Typeface, TextHeight, Weight, Style)
		
		; Transparent background, no color needed
		DllCall("SetBkMode", "UPtr", this.hMemDC, "Int", 1)
		;DllCall("SetBkColor", "UPtr", this.hMemDC, "UInt", 0xFFFFFF)
		
		DllCall("SetTextColor", "UPtr", this.hMemDC, "UInt", Color)
		hOriginalFont := DllCall("SelectObject", "UPtr", this.hMemDC, "UPtr", Font.Handle, "UPtr")
		
		x1 := this.TranslateX(x)
		y1 := this.TranslateY(y)
		x2 := this.TranslateX(x+w)
		y2 := this.TranslateY(y+h)
		if (y1 > y2) ; Fix the coordinates when inverted
			tmp := y1, y1 := y2, y2 := tmp
		
		; TODO: abstract RECTs
		VarSetCapacity(Rect, 16, 0)
		NumPut(x1, Rect, 0, "Int"), NumPut(y1, Rect, 4, "Int")
		NumPut(x2, Rect, 8, "Int"), NumPut(y2, Rect, 12, "Int")
		
		DllCall("DrawText", "UPtr", this.hMemDC, "Str", Text, "Int", -1, "UPtr", &Rect, "UInt", AlignH[Align[1]] | AlignV[Align[2]])
		DllCall("SelectObject", "UPtr", this.hMemDC, "UPtr", hOriginalFont, "UPtr")
	}
	
	FillRectangle(x, y, w, h, Color, BorderColor=-1)
	{
		if (w == 1 && h == 1)
			return this.SetPixel(x, y, Color)
		
		Pen := new this.Pen(BorderColor < 0 ? Color : BorderColor)
		Brush := new this.Brush(Color)
		
		; Replace the original pen and brush with our own
		hOriginalPen := DllCall("SelectObject", "UPtr", this.hMemDC, "UPtr", Pen.Handle, "UPtr")
		hOriginalBrush := DllCall("SelectObject", "UPtr", this.hMemDC, "UPtr", Brush.Handle, "UPtr")
		
		x1 := this.TranslateX(x)
		x2 := this.TranslateX(x+w)
		y1 := this.TranslateY(y)
		y2 := this.TranslateY(y+h)
		
		DllCall("Rectangle", "UPtr", this.hMemDC
		, "Int", x1, "Int", y1
		, "Int", x2, "Int", y2)
		
		; Reselect the original pen and brush
		DllCall("SelectObject", "UPtr", this.hMemDC, "UPtr", hOriginalPen, "UPtr")
		DllCall("SelectObject", "UPtr", this.hMemDC, "UPtr", hOriginalBrush, "UPtr")
	}
	
	TranslateX(X)
	{
		return Floor(X)
	}
	
	TranslateY(Y, Offset=0)
	{
		if this.Invert
			return this.CliHeight - Floor(Y) - Offset
		return Floor(Y)
	}
	
	class Pen
	{
		__New(Color, Width=1, Style=0)
		{
			this.Handle := DllCall("CreatePen", "Int", Style, "Int", Width, "UInt", Color, "UPtr")
		}
		
		__Delete()
		{
			DllCall("DeleteObject", "UPtr", this.Handle)
		}
	}
	
	class Brush
	{
		__New(Color)
		{
			this.Handle := DllCall("CreateSolidBrush", "UInt", Color, "UPtr")
		}
		
		__Delete()
		{
			DllCall("DeleteObject", "UPtr", this.Handle)
		}
	}
	
	class Font
	{
		__New(Typeface, Height, Weight, Style)
		{
			this.Handle := DllCall("CreateFont"
			, "Int", Height ;height
			, "Int", 0 ;width
			, "Int", 0 ;angle of string (0.1 degrees)
			, "Int", 0 ;angle of each character (0.1 degrees)
			, "Int", Weight ;font weight
			, "UInt", Style&1 ;font italic
			, "UInt", Style&2 ;font underline
			, "UInt", Style&4 ;font strikeout
			, "UInt", 1 ;DEFAULT_CHARSET: character set
			, "UInt", 0 ;OUT_DEFAULT_PRECIS: output precision
			, "UInt", 0 ;CLIP_DEFAULT_PRECIS: clipping precision
			, "UInt", 0 ;DEFAULT_QUALITY: output quality
			, "UInt", 0 ;DEFAULT_PITCH | (FF_DONTCARE << 16): font pitch and family
			, "Str", Typeface ;typeface name
			, "UPtr")
		}
		
		__Delete()
		{
			DllCall("DeleteObject", "UPtr", this.Handle)
		}
	}
}
